import wcs, es, random, gamethread, playerlib
from wcs import wcs
#Our Race's Name - This is not needed I just feel it makes things look cleaner
RaceName = 'Succubus Hunter'
wcs.Race(RaceName).registerSkill("Demonic Knife", 4, 4, "Deal extra damage with your knife.")
wcs.Race(RaceName).registerSkill("Bone Collector", 10, 2, "Collect Bones and XP by killing opponents.")
wcs.Race(RaceName).registerSkill("Totem Incantation", 5, 5, "Receive extra HP and money from each bone.")
wcs.Race(RaceName).registerSkill("Assault Tackle", 3, 2, "Speed plus Low Grav and Long Jump.")
wcs.Race(RaceName).registerUltimate("Deamonic Transformation", 8, 8, 6, "Become A beast. (Knife Ultimate, gain HP, Speed and Extra Damage.)")
wcs.Race(RaceName).registerMinLevel(125)
 
def load():
	es.doblock('corelib/noisy_on')
 
def unload():
	es.doblock('corelib/noisy_off')
	
def player_death(ev):
    attacker = ev['attacker']
    effect = wcs.Effect()
    if wcs.GetRace(attacker) == RaceName:
        if wcs.GetLevel(attacker, RaceName, 'Bone Collector'):
                team = ev['es_userteam']
                team2 = ev['es_attackerteam']
                if team != team2:
                      bonelvl = wcs.GetLevel(attacker, RaceName, 'Bone Collector')
                      bones = random.randint(1,bonelvl)
                      wcs.Command(attacker).ModDict('bones', + bones)
                      wcs.Command(attacker).GiveXp(20)
                      es.tell(attacker, "#green", "Your Bone collection has increased By %s and you gained 20xp!"%bones)

def player_hurt(ev):
    userid = ev['userid']
    attacker = ev['attacker']
    weapon = ev['weapon']
    demon_knife = wcs.GetLevel(attacker, RaceName, 'Demonic Knife')
    dform = wcs.Command(attacker).ReturnDict('daemondmg')
    if demon_knife and dform < 1 :
        if weapon == "knife":
            wcs.Effect().Beam2(attacker, userid, 5, 255, 0, 0)
            demondmg = int(demon_knife * 3)
            name1 = ev['es_username']
            name2 = ev['es_attackername']
            wcs.Command(userid).Damage(demon_knife * 3, 32, attacker)
            es.tell(attacker, '#multi' , '#lightgreenYour Demonic Knife did#green %s #lightgreenextra damage to#green %s.'%(demondmg, name1))
            es.tell(userid, '#multi' , '#green %s #lightgreendid#green %s #lightgreenextra damage to you with his Demonic Knife!!'%(name2, demondmg))
    if dform >= 1:
        wcs.Effect().Beam2(attacker, userid, 5, 255, 0, 0)
        name1 = ev['es_username']
        name2 = ev['es_attackername']
        wcs.Command(userid).Damage(dform, 32, attacker)
        es.tell(attacker, '#multi' , '#lightgreenYour Demonic Claws did#green %s #lightgreenextra damage to#green %s.'%(dform, name1))
        es.tell(userid, '#multi' , '#green %s #lightgreendid#green %s #lightgreenextra damage to you with his Demonic Claws!!'%(name2, dform))
                                    
                
def player_activate(ev):
    userid = ev['userid']
    wcs.Command(userid).UpdateDict('bones', 0)
    
def es_map_start(ev):
    userid = ev['userid']
    wcs.Command(userid).UpdateDict('bones', 0)                    
 
def player_spawn(ev):
    userid = ev['userid']
    player = wcs.Command(userid)
    wcs.Command(userid).UpdateDict('daemondmg', 0)
    es.server.queuecmd('est_UnrestrictAll %s'%ev['userid'])
    assault = wcs.GetLevel(userid, RaceName, 'Assault Tackle')
    if assault:
        wcs.Effect().Misc2(userid, 3, 2)
        alevel = assault * 10 * .01
        player.SpeedAdd(alevel)
        alevelt = int(alevel * 100)
        adepth = 1 - assault * 15 * .01
        player.SetGravity(adepth)
        adeptht = int(adepth * 100)
        es.tell(userid, '#multi', '#lightgreenYou gained#green %s #lightgreenSpeed, lost#green %s #lightgreenGravity and gained #greenLong-Jump!'%(alevelt, adeptht))
    if wcs.GetRace(userid) == RaceName:
        es.server.queuecmd('est_unrestrict userid')
        bones = wcs.Command(userid).ReturnDict('bones')
        es.tell(userid, '#green', 'You have %s Bones' %bones)
    Totem = wcs.GetLevel(userid, RaceName, 'Totem Incantation')
    if Totem:
       if bones != 0:
          if bones <= 50:
              wcs.Command(userid).HealthAdd(bones)
              cash = playerlib.getPlayer(userid).get('cash')
              money = int(bones * 20 + cash)
              moneyamt= int(bones * 20)
              playerlib.getPlayer(userid).set('cash', + money)
              es.tell(userid, '#multi', '#lightgreenYou have gained#green %s #lightgreenHP and#green %s #lightgreendollars from your Bone Totem.'%(bones, moneyamt))          
          elif bones > 50:
              wcs.Command(userid).HealthAdd(75)
              cash = playerlib.getPlayer(userid).get('cash')
              money = int(1500 + cash)
              playerlib.getPlayer(userid).set('cash', + money)
              es.tell(userid, '#multi', '#lightgreenYou have gained#green 75 #lightgreenHP and 1500 dollars from your Bone Totem.')      
        
        
def player_jump(ev):
    userid = ev['userid']
    LongJump = wcs.GetLevel(userid, RaceName, 'Assault Tackle')*2.5
    if LongJump: 
        wcs.Effect().Ring1(userid, 500, 1, 125, 75, 180)
        vec1 = es.getplayerprop(userid,'CBasePlayer.localdata.m_vecVelocity[0]')
        vec2 = es.getplayerprop(userid,'CBasePlayer.localdata.m_vecVelocity[1]')
        vec1 = (LongJump * vec1) * (1 / 4.1)
        vec2 = (LongJump * vec2) * (1 / 4.1)
        vector = es.createvectorstring(vec1,vec2,0)
        es.setplayerprop(userid,'CBasePlayer.localdata.m_vecBaseVelocity',vector)
    
def round_start(ev):
    es.cexec('#a','-ultimate')
    
def player_disconnect(ev):    
    if es.exists('key', 'bones', userid):
        es.keydelete('bones', userid)
    if es.exists('key', 'daemondmg', userid):
        es.keydelete('daemondmg', userid)    
        
def player_ultimate_on(ev):
    userid = int(ev['userid'])
    x,y,z = es.getplayerlocation(userid)
    Demon_level = wcs.GetLevel(userid, RaceName, 'Deamonic Transformation')
    if Demon_level:
       effect = wcs.Effect()
       effect.Smoke(userid)
       es.tell(userid, '#green', 'Holy SHIT!!! You are Transforming')
       wcs.Command(userid).Push(0,0,300)
       effect.Ring2(userid, 200, 2, 255, 25, 50)
       effect.Ring2(userid, 300, 2, 25, 255, 50)
       effect.Ring2(userid, 400, 2, 50, 25, 255)
       wcs.Command(userid).Shake(2,5)   
       wcs.Command(userid).HealthAdd(Demon_level * 5)
       effect.RingCustom('#a', 2, 'sprites/plasma1.vmt', x, y, z, 30, 250, 2, 40, 20, 50,  200, 200, 200, 255, 4)
       wcs.Command(userid).SpeedAdd(Demon_level/8.0)
       gamethread.delayed(2, Transformation, userid)
       wcs.Command(userid).Freeze(2)
       es.server.queuecmd('est_RestrictAll %s'%userid)
       wcs.Command(userid).UpdateDict('daemondmg', Demon_level * 4)
       wcs.Command(userid).SetCoolDown('Deamonic Transformation',900)
  
def Transformation(userid):
    Demon_level = wcs.GetLevel(userid, RaceName, 'Deamonic Transformation')
    if Demon_level:
        effect = wcs.Effect()
        effect.Misc3(userid, 2, 80)
        es.tell(userid, '#green', 'You Feel A lot Stronger Now')
        es.server.queuecmd('est_unrestrict %s %s'%(userid,'weapon_knife'))
        es.server.queuecmd('es_xgive %s %s' % (userid, 'weapon_knife'))
                    